// Copyright (C) 2019 - 2023 by Pedro Mendes, Rector and Visitors of the
// University of Virginia, University of Heidelberg, and University
// of Connecticut School of Medicine.
// All rights reserved.

// Copyright (C) 2017 - 2018 by Pedro Mendes, Virginia Tech Intellectual
// Properties, Inc., University of Heidelberg, and University of
// of Connecticut School of Medicine.
// All rights reserved.

// Copyright (C) 2010 - 2016 by Pedro Mendes, Virginia Tech Intellectual
// Properties, Inc., University of Heidelberg, and The University
// of Manchester.
// All rights reserved.

// Copyright (C) 2008 - 2009 by Pedro Mendes, Virginia Tech Intellectual
// Properties, Inc., EML Research, gGmbH, University of Heidelberg,
// and The University of Manchester.
// All rights reserved.

// Copyright (C) 2003 - 2007 by Pedro Mendes, Virginia Tech Intellectual
// Properties, Inc. and EML Research, gGmbH.
// All rights reserved.

static char FunctionDBxml[] =
  "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
  "<!-- generated with COPASI (http://www.copasi.org) -->\n"
  "<COPASI xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:noNamespaceSchemaLocation=\"http://calvin.bioinformatics.vt.edu/copasi/schema/copasi.xsd\">\n"
  "<ListOfFunctions>\n"
  "<Function key=\"Function_0\" name=\"Allosteric inhibition (MWC)\" type=\"PreDefined\" reversible=\"false\">\n"
  "<Expression>\n"
  "V*(substrate/Ks)*(1+(substrate/Ks))^(n-1)/(L*(1+Inhibitor/Ki)^n+(1+(substrate/Ks))^n)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_0\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_1\" name=\"Inhibitor\" order=\"1\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_2\" name=\"V\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_3\" name=\"Ks\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_4\" name=\"n\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_5\" name=\"L\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_6\" name=\"Ki\" order=\"6\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_1\" name=\"Allosteric inhibition (empirical)\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "(Vf*substrate/Kms-Vr*product/Kmp)/(1+substrate/Kms+product/Kmp+(Inhibitor/Ki)^n)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_7\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_8\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_9\" name=\"Inhibitor\" order=\"2\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_10\" name=\"Vf\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_11\" name=\"Vr\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_12\" name=\"Kms\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_13\" name=\"Kmp\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_14\" name=\"n\" order=\"7\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_15\" name=\"Ki\" order=\"8\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_2\" name=\"Catalytic activation (irrev)\" type=\"PreDefined\" reversible=\"false\">\n"
  "<Expression>\n"
  "V*substrate*Activator/((Kms+substrate)*(Ka+Activator))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_16\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_17\" name=\"Activator\" order=\"1\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_18\" name=\"Kms\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_19\" name=\"V\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_20\" name=\"Ka\" order=\"4\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_3\" name=\"Catalytic activation (rev)\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "(Vf*substrate/Kms-Vr*product/Kmp)*Activator/((1+substrate/Kms+product/Kmp)*(Ka+Activator))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_21\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_22\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_23\" name=\"Activator\" order=\"2\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_24\" name=\"Kms\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_25\" name=\"Kmp\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_26\" name=\"Vf\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_27\" name=\"Vr\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_28\" name=\"Ka\" order=\"7\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_4\" name=\"Competitive inhibition (irr)\" type=\"PreDefined\" reversible=\"false\">\n"
  "<Expression>\n"
  "V*substrate/(Km+substrate+Km*Inhibitor/Ki)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_29\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_30\" name=\"Inhibitor\" order=\"1\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_31\" name=\"Km\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_32\" name=\"V\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_33\" name=\"Ki\" order=\"4\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_5\" name=\"Competitive inhibition (rev)\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "(Vf*substrate/Kms-Vr*product/Kmp)/(1+substrate/Kms+product/Kmp+Inhibitor/Ki)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_34\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_35\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_36\" name=\"Inhibitor\" order=\"2\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_37\" name=\"Kms\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_38\" name=\"Kmp\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_39\" name=\"Vf\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_40\" name=\"Vr\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_41\" name=\"Ki\" order=\"7\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_6\" name=\"Constant flux (irreversible)\" type=\"PreDefined\" reversible=\"false\">\n"
  "<Expression>\n"
  "v\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_42\" name=\"v\" order=\"0\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_7\" name=\"Constant flux (reversible)\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "v\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_43\" name=\"v\" order=\"0\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_8\" name=\"Henri-Michaelis-Menten (irreversible)\" type=\"PreDefined\" reversible=\"false\">\n"
  "<Expression>\n"
  "V*substrate/(Km+substrate)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_44\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_45\" name=\"Km\" order=\"1\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_46\" name=\"V\" order=\"2\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_9\" name=\"Hill Cooperativity\" type=\"PreDefined\" reversible=\"false\">\n"
  "<Expression>\n"
  "V*(substrate/Shalve)^h/(1+(substrate/Shalve)^h)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_47\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_48\" name=\"Shalve\" order=\"1\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_49\" name=\"V\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_50\" name=\"h\" order=\"3\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_10\" name=\"Hyperbolic modifier (irrev)\" type=\"PreDefined\" reversible=\"false\">\n"
  "<Expression>\n"
  "V*substrate*(1+b*Modifier/(a*Kd))/(Km*(1+Modifier/Kd)+substrate*(1+Modifier/(a*Kd)))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_51\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_52\" name=\"Modifier\" order=\"1\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_53\" name=\"Km\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_54\" name=\"V\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_55\" name=\"Kd\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_56\" name=\"a\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_57\" name=\"b\" order=\"6\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_11\" name=\"Hyperbolic modifier (rev)\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "(Vf*substrate/Kms-Vr*product/Kmp)*(1+b*Modifier/(a*Kd))/(1+Modifier/Kd+(substrate/Kms+product/Kmp)*(1+Modifier/(a*Kd)))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_58\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_59\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_60\" name=\"Modifier\" order=\"2\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_61\" name=\"Kms\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_62\" name=\"Kmp\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_63\" name=\"Vf\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_64\" name=\"Vr\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_65\" name=\"Kd\" order=\"7\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_66\" name=\"a\" order=\"8\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_67\" name=\"b\" order=\"9\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_12\" name=\"Iso Uni Uni\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "Vf*(substrate-product/Keq)/(substrate*(1+product/Kii)+Kms*(1+product/Kmp))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_68\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_69\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_70\" name=\"Kms\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_71\" name=\"Kmp\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_72\" name=\"Kii\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_73\" name=\"Vf\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_74\" name=\"Keq\" order=\"6\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_13\" name=\"Mass action (irreversible)\" type=\"MassAction\" reversible=\"false\">\n"
  "  <MiriamAnnotation>\n"
  "   <rdf:RDF xmlns:CopasiMT=\"http://www.copasi.org/RDF/MiriamTerms#\" xmlns:dcterms=\"http://purl.org/dc/terms/\" xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\">\n"
  "   <rdf:Description rdf:about=\"#Function_13\">\n"
  "   <CopasiMT:is rdf:resource=\"urn:miriam:obo.sbo:SBO:0000163\"/>\n"
  "   </rdf:Description>\n"
  "   </rdf:RDF>\n"
  "  </MiriamAnnotation>\n"
  "  <Comment>\n"
  "<body xmlns=\"http://www.w3.org/1999/xhtml\">\n"
  "<b>Mass action rate law for irreversible reactions</b>\n"
  "<p>\n"
  "Reaction scheme where the products are created from the reactants and the change of a product quantity is proportional to the product of reactant activities. The reaction scheme does not include any reverse process that creates the reactants from the products. The change of a product quantity is proportional to the quantity of one reactant.\n"
  "</p>\n"
  "</body>\n"
  "  </Comment>\n"
  "<Expression>\n"
  "k1*PRODUCT&lt;substrate_i&gt;\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_75\" name=\"k1\" order=\"0\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_76\" name=\"substrate\" order=\"1\" role=\"substrate\" minOccurs=\"1\" maxOccurs=\"unbounded\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_14\" name=\"Mass action (reversible)\" type=\"MassAction\" reversible=\"true\">\n"
  "  <MiriamAnnotation>\n"
  "   <rdf:RDF xmlns:CopasiMT=\"http://www.copasi.org/RDF/MiriamTerms#\" xmlns:dcterms=\"http://purl.org/dc/terms/\" xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\">\n"
  "   <rdf:Description rdf:about=\"#Function_14\">\n"
  "   <CopasiMT:is rdf:resource=\"urn:miriam:obo.sbo:SBO:0000042\"/>\n"
  "   </rdf:Description>\n"
  "   </rdf:RDF>\n"
  "  </MiriamAnnotation>\n"
  "  <Comment>\n"
  "<body xmlns=\"http://www.w3.org/1999/xhtml\">\n"
  "<b>Mass action rate law for reversible reactions</b>\n"
  "<p>\n"
  "Reaction scheme where the products are created from the reactants and the change of a product quantity is proportional to the product of reactant activities. The reaction scheme does include a reverse process that creates the reactants from the products.\n"
  "</p>\n"
  "</body>\n"
  "  </Comment>\n"
  "<Expression>\n"
  "k1*PRODUCT&lt;substrate_i&gt;-k2*PRODUCT&lt;product_j&gt;\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_77\" name=\"k1\" order=\"0\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_78\" name=\"substrate\" order=\"1\" role=\"substrate\" minOccurs=\"1\" maxOccurs=\"unbounded\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_79\" name=\"k2\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_80\" name=\"product\" order=\"3\" role=\"product\" minOccurs=\"1\" maxOccurs=\"unbounded\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_15\" name=\"Mixed activation (irrev)\" type=\"PreDefined\" reversible=\"false\">\n"
  "<Expression>\n"
  "V*substrate*Activator/(Kms*(Kas+Activator)+substrate*(Kac+Activator))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_81\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_82\" name=\"Activator\" order=\"1\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_83\" name=\"Kms\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_84\" name=\"V\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_85\" name=\"Kas\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_86\" name=\"Kac\" order=\"5\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_16\" name=\"Mixed activation (rev)\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "(Vf*substrate/Kms-Vr*product/Kmp)*Activator/(Kas+Activator+(substrate/Kms+product/Kmp)*(Kac+Activator))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_87\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_88\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_89\" name=\"Activator\" order=\"2\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_90\" name=\"Kms\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_91\" name=\"Kmp\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_92\" name=\"Vf\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_93\" name=\"Vr\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_94\" name=\"Kas\" order=\"7\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_95\" name=\"Kac\" order=\"8\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_17\" name=\"Mixed inhibition (irr)\" type=\"PreDefined\" reversible=\"false\">\n"
  "<Expression>\n"
  "V*substrate/(Km*(1+Inhibitor/Kis)+substrate*(1+Inhibitor/Kic))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_96\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_97\" name=\"Inhibitor\" order=\"1\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_98\" name=\"Km\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_99\" name=\"V\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_100\" name=\"Kis\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_101\" name=\"Kic\" order=\"5\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_18\" name=\"Mixed inhibition (rev)\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "(Vf*substrate/Kms-Vr*product/Kmp)/(1+Inhibitor/Kis+(substrate/Kms+product/Kmp)*(1+Inhibitor/Kic))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_102\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_103\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_104\" name=\"Inhibitor\" order=\"2\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_105\" name=\"Kms\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_106\" name=\"Kmp\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_107\" name=\"Vf\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_108\" name=\"Vr\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_109\" name=\"Kis\" order=\"7\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_110\" name=\"Kic\" order=\"8\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_19\" name=\"Noncompetitive inhibition (irr)\" type=\"PreDefined\" reversible=\"false\">\n"
  "<Expression>\n"
  "V*substrate/((Km+substrate)*(1+Inhibitor/Ki))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_111\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_112\" name=\"Inhibitor\" order=\"1\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_113\" name=\"Km\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_114\" name=\"V\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_115\" name=\"Ki\" order=\"4\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_20\" name=\"Noncompetitive inhibition (rev)\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "(Vf*substrate/Kms-Vr*product/Kmp)/((1+substrate/Kms+product/Kmp)*(1+Inhibitor/Ki))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_116\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_117\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_118\" name=\"Inhibitor\" order=\"2\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_119\" name=\"Kms\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_120\" name=\"Kmp\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_121\" name=\"Vf\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_122\" name=\"Vr\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_123\" name=\"Ki\" order=\"7\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_21\" name=\"Ordered Bi Bi\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "Vf*(substratea*substrateb-productp*productq/Keq)/(substratea*substrateb*(1+productp/Kip)+Kma*substrateb+Kmb*(substratea+Kia)+Vf/(Vr*Keq)*(Kmq*productp*(1+substratea/Kia)+productq*(Kmp*(1+Kma*substrateb/(Kia*Kmb))+productp*(1+substrateb/Kib))))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_124\" name=\"substratea\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_125\" name=\"substrateb\" order=\"1\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_126\" name=\"productp\" order=\"2\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_127\" name=\"productq\" order=\"3\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_128\" name=\"Keq\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_129\" name=\"Vf\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_130\" name=\"Vr\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_131\" name=\"Kma\" order=\"7\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_132\" name=\"Kmb\" order=\"8\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_133\" name=\"Kmp\" order=\"9\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_134\" name=\"Kmq\" order=\"10\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_135\" name=\"Kia\" order=\"11\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_136\" name=\"Kib\" order=\"12\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_137\" name=\"Kip\" order=\"13\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_22\" name=\"Ordered Bi Uni\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "Vf*(substratea*substrateb-product/Keq)/(substratea*substrateb+Kma*substrateb+Kmb*substratea+Vf/(Vr*Keq)*(Kmp+product*(1+substratea/Kia)))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_138\" name=\"substratea\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_139\" name=\"substrateb\" order=\"1\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_140\" name=\"product\" order=\"2\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_141\" name=\"Kma\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_142\" name=\"Kmb\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_143\" name=\"Kmp\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_144\" name=\"Kia\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_145\" name=\"Keq\" order=\"7\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_146\" name=\"Vf\" order=\"8\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_147\" name=\"Vr\" order=\"9\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_23\" name=\"Ordered Uni Bi\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "Vf*(substrate-productp*productq/Keq)/(Kms+substrate*(1+productp/Kip)+Vf/(Vr*Keq)*(Kmq*productp+Kmp*productq+productp*productq))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_148\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_149\" name=\"productp\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_150\" name=\"productq\" order=\"2\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_151\" name=\"Kms\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_152\" name=\"Kmq\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_153\" name=\"Kmp\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_154\" name=\"Kip\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_155\" name=\"Keq\" order=\"7\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_156\" name=\"Vf\" order=\"8\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_157\" name=\"Vr\" order=\"9\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_24\" name=\"Ping Pong Bi Bi\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "Vf*(substratea*substrateb-productp*productq/Keq)/(substratea*substrateb+Kmb*substratea+Kma*substrateb*(1+productq/Kiq)+Vf/(Vr*Keq)*(Kmq*productp*(1+substratea/Kia)+productq*(Kmp+productp)))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_158\" name=\"substratea\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_159\" name=\"substrateb\" order=\"1\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_160\" name=\"productp\" order=\"2\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_161\" name=\"productq\" order=\"3\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_162\" name=\"Keq\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_163\" name=\"Vf\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_164\" name=\"Vr\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_165\" name=\"Kma\" order=\"7\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_166\" name=\"Kmb\" order=\"8\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_167\" name=\"Kmp\" order=\"9\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_168\" name=\"Kmq\" order=\"10\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_169\" name=\"Kia\" order=\"11\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_170\" name=\"Kiq\" order=\"12\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_25\" name=\"Reversible Hill 1 modifier\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "Vf*substrate/Shalve*(1-product/(substrate*Keq))*(substrate/Shalve+product/Phalve)^(h-1)/((1+(Modifier/Mhalve)^h)/(1+alpha*(Modifier/Mhalve)^h)+(substrate/Shalve+product/Phalve)^h)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_171\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_172\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_173\" name=\"Modifier\" order=\"2\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_174\" name=\"Keq\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_175\" name=\"Vf\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_176\" name=\"Shalve\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_177\" name=\"Phalve\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_178\" name=\"h\" order=\"7\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_179\" name=\"Mhalve\" order=\"8\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_180\" name=\"alpha\" order=\"9\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_26\" name=\"Reversible Hill 2 modifiers\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "Vf*substrate/Shalve*(1-product/(substrate*Keq))*(substrate/Shalve+product/Phalve)^(h-1)/((1+(ModifierA/MAhalve)^h+(ModifierB/MBhalve)^h)/(1+alphaA*(ModifierA/MAhalve)^h+alphaB*(ModifierB/MBhalve)^h+alphaA*alphaB*alphaAB*(ModifierA/MAhalve)^h*(ModifierB/MBhalve)^h)+(substrate/Shalve+product/Phalve)^h)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_181\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_182\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_183\" name=\"ModifierA\" order=\"2\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_184\" name=\"ModifierB\" order=\"3\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_185\" name=\"Keq\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_186\" name=\"Vf\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_187\" name=\"Shalve\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_188\" name=\"Phalve\" order=\"7\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_189\" name=\"h\" order=\"8\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_190\" name=\"MAhalve\" order=\"9\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_191\" name=\"alphaA\" order=\"10\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_192\" name=\"MBhalve\" order=\"11\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_193\" name=\"alphaB\" order=\"12\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_194\" name=\"alphaAB\" order=\"13\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_27\" name=\"Reversible Hill\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "Vf*substrate/Shalve*(1-product/(substrate*Keq))*(substrate/Shalve+product/Phalve)^(h-1)/(1+(substrate/Shalve+product/Phalve)^h)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_195\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_196\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_197\" name=\"Keq\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_198\" name=\"Vf\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_199\" name=\"Shalve\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_200\" name=\"Phalve\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_201\" name=\"h\" order=\"6\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_28\" name=\"Reversible Michaelis-Menten\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "(Vf*substrate/Kms-Vr*product/Kmp)/(1+substrate/Kms+product/Kmp)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_202\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_203\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_204\" name=\"Kms\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_205\" name=\"Kmp\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_206\" name=\"Vf\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_207\" name=\"Vr\" order=\"5\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_29\" name=\"Specific activation (irrev)\" type=\"PreDefined\" reversible=\"false\">\n"
  "<Expression>\n"
  "V*substrate*Activator/(Kms*Ka+(Kms+substrate)*Activator)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_208\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_209\" name=\"Activator\" order=\"1\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_210\" name=\"Kms\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_211\" name=\"V\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_212\" name=\"Ka\" order=\"4\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_30\" name=\"Specific activation (rev)\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "(Vf*substrate/Kms-Vr*product/Kmp)*Activator/(Ka+(1+substrate/Kms+product/Kmp)*Activator)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_213\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_214\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_215\" name=\"Activator\" order=\"2\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_216\" name=\"Kms\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_217\" name=\"Kmp\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_218\" name=\"Vf\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_219\" name=\"Vr\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_220\" name=\"Ka\" order=\"7\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_31\" name=\"Substrate activation (irr)\" type=\"PreDefined\" reversible=\"false\">\n"
  "<Expression>\n"
  "V*(substrate/Ksa)^2/(1+substrate/Ksc+substrate/Ksa+(substrate/Ksa)^2)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_221\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_222\" name=\"V\" order=\"1\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_223\" name=\"Ksc\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_224\" name=\"Ksa\" order=\"3\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_32\" name=\"Substrate inhibition (irr)\" type=\"PreDefined\" reversible=\"false\">\n"
  "<Expression>\n"
  "V*substrate/(Km+substrate+Km*(substrate/Ki)^2)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_225\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_226\" name=\"Km\" order=\"1\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_227\" name=\"V\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_228\" name=\"Ki\" order=\"3\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_33\" name=\"Substrate inhibition (rev)\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "(Vf*substrate/Kms-Vr*product/Kmp)/(1+substrate/Kms+product/Kmp+(substrate/Ki)^2)\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_229\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_230\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_231\" name=\"Kms\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_232\" name=\"Kmp\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_233\" name=\"Vf\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_234\" name=\"Vr\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_235\" name=\"Ki\" order=\"6\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_34\" name=\"Uncompetitive inhibition (irr)\" type=\"PreDefined\" reversible=\"false\">\n"
  "<Expression>\n"
  "V*substrate/(Km+substrate*(1+Inhibitor/Ki))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_236\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_237\" name=\"Inhibitor\" order=\"1\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_238\" name=\"Km\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_239\" name=\"V\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_240\" name=\"Ki\" order=\"4\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_35\" name=\"Uncompetitive inhibition (rev)\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "(Vf*substrate/Kms-Vr*product/Kmp)/(1+(substrate/Kms+product/Kmp)*(1+Inhibitor/Ki))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_241\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_242\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_243\" name=\"Inhibitor\" order=\"2\" role=\"modifier\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_244\" name=\"Kms\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_245\" name=\"Kmp\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_246\" name=\"Vf\" order=\"5\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_247\" name=\"Vr\" order=\"6\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_248\" name=\"Ki\" order=\"7\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_36\" name=\"Uni Uni\" type=\"PreDefined\" reversible=\"true\">\n"
  "<Expression>\n"
  "Vf*(substrate-product/Keq)/(substrate+Kms*(1+product/Kmp))\n"
  "</Expression>"
  "<ListOfParameterDescriptions>\n"
  "<ParameterDescription key=\"FunctionParameter_249\" name=\"substrate\" order=\"0\" role=\"substrate\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_250\" name=\"product\" order=\"1\" role=\"product\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_251\" name=\"Kms\" order=\"2\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_252\" name=\"Kmp\" order=\"3\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_253\" name=\"Vf\" order=\"4\" role=\"constant\"/>\n"
  "<ParameterDescription key=\"FunctionParameter_254\" name=\"Keq\" order=\"5\" role=\"constant\"/>\n"
  "</ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_37\" name=\"Bi (irreversible)\" type=\"PreDefined\" reversible=\"false\">\n"
  "  <MiriamAnnotation>\n"
  "<rdf:RDF xmlns:CopasiMT=\"http://www.copasi.org/RDF/MiriamTerms#\" xmlns:dcterms=\"http://purl.org/dc/terms/\" xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\">\n"
  "<rdf:Description rdf:about=\"#Function_37\">\n"
  "<CopasiMT:is rdf:resource=\"urn:miriam:obo.sbo:SBO:0000151\"/>\n"
  "</rdf:Description>\n"
  "</rdf:RDF>\n"
  "  </MiriamAnnotation>\n"
  "  <Comment>\n"
  "    enzymatic rate law for irreversible non-modulated non-interacting bireactant enzymes\n"
  "  </Comment>\n"
  "  <Expression>\n"
  "    vmax*A*B/(Kma*Kmb + A*Kmb + B*Kma + A*B)\n"
  "  </Expression>\n"
  "  <ListOfParameterDescriptions>\n"
  "    <ParameterDescription key=\"FunctionParameter_255\" name=\"vmax\" order=\"0\" role=\"constant\"/>\n"
  "    <ParameterDescription key=\"FunctionParameter_256\" name=\"A\" order=\"1\" role=\"substrate\"/>\n"
  "    <ParameterDescription key=\"FunctionParameter_257\" name=\"B\" order=\"2\" role=\"substrate\"/>\n"
  "    <ParameterDescription key=\"FunctionParameter_258\" name=\"Kma\" order=\"3\" role=\"constant\"/>\n"
  "    <ParameterDescription key=\"FunctionParameter_259\" name=\"Kmb\" order=\"4\" role=\"constant\"/>\n"
  "  </ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_38\" name=\"Arrhenius Bimolecular (irr)\" type=\"PreDefined\" reversible=\"false\">\n"
  "  <Expression>\n"
  "    A*exp(-Ea/(R*T))*S1*S2\n"
  "  </Expression>\n"
  "  <ListOfParameterDescriptions>\n"
  "    <ParameterDescription key=\"FunctionParameter_264\" name=\"A\" order=\"0\" role=\"constant\"/>\n"
  "    <ParameterDescription key=\"FunctionParameter_299\" name=\"Ea\" order=\"1\" role=\"constant\"/>\n"
  "    <ParameterDescription key=\"FunctionParameter_261\" name=\"R\" order=\"2\" role=\"constant\"/>\n"
  "    <ParameterDescription key=\"FunctionParameter_284\" name=\"T\" order=\"3\" role=\"constant\"/>\n"
  "    <ParameterDescription key=\"FunctionParameter_292\" name=\"S1\" order=\"4\" role=\"substrate\"/>\n"
  "    <ParameterDescription key=\"FunctionParameter_301\" name=\"S2\" order=\"5\" role=\"substrate\"/>\n"
  "  </ListOfParameterDescriptions>\n"
  "</Function>\n"
  "<Function key=\"Function_43\" name=\"Arrhenius Unimolecular (irr)\" type=\"PreDefined\" reversible=\"false\">\n"
  "  <Expression>\n"
  "    A*exp(-Ea/(R*T))*S\n"
  "  </Expression>\n"
  "  <ListOfParameterDescriptions>\n"
  "    <ParameterDescription key=\"FunctionParameter_266\" name=\"A\" order=\"0\" role=\"constant\"/>\n"
  "    <ParameterDescription key=\"FunctionParameter_276\" name=\"Ea\" order=\"1\" role=\"constant\"/>\n"
  "    <ParameterDescription key=\"FunctionParameter_290\" name=\"R\" order=\"2\" role=\"constant\"/>\n"
  "    <ParameterDescription key=\"FunctionParameter_285\" name=\"T\" order=\"3\" role=\"constant\"/>\n"
  "    <ParameterDescription key=\"FunctionParameter_293\" name=\"S\" order=\"4\" role=\"substrate\"/>\n"
  "  </ListOfParameterDescriptions>\n"
  "</Function>\n"
  "</ListOfFunctions>\n"
  "</COPASI>\n"
  ;
